#include "libcom.h"
#include "libthrd.h"
#include <dirent.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <stddef.h>
#include <fcntl.h>
#include <netdb.h>
#include <string.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/stat.h>
#include <netinet/in.h>
#include <netinet/tcp.h>
#include <arpa/inet.h>
#include <fcntl.h>

/** Constantes **/
#define MAX_LIGNE 2048
#define MAX_TAMPON 1024
#define MAX_UDP_MESSAGE 256

/** Variables publiques **/

/** Variables statiques **/

/** Procedure principale **/

int adresse=0;

int count_files(char *repertoire) // SUR INTERNET
{

	int file_count = 0;
	DIR * dir;
	struct dirent * entry;

	dir = opendir(repertoire); /* There should be error handling after this */
	while ((entry = readdir(dir)) != NULL) {
	    if (entry->d_type == DT_REG) { /* If the entry is a regular file */
		 file_count++;
	    }
	}
	closedir(dir);
	printf("le nombre de fichier est de: %d\n", file_count);
	return file_count;
}

int find_exped(char *fileName,char *strSearch) // SUR INTERNET
{

  FILE *fd;
  char c;
  int found=0;
  int pos=0;
  int length;

  fd = fopen(fileName,"r");
  if( fd == NULL )
    return 0;

  length=strlen(strSearch);

  while( fread(&c,1,1,fd)>0 && !found ) {

    if( c==strSearch[pos] ) {
      pos++;
    } else {
      if(pos!=0) {
        fseek(fd,-pos,SEEK_CUR);
        pos=0;
      }
    }

    found = (pos==length);

  }
  fclose(fd);

  return found;

}

void commandeHELO(char *buffer, int s)
{
	char buffer_sortie[1024];
	sprintf(buffer_sortie, "250 OK\r\n");
	send(s, buffer_sortie, strlen(buffer_sortie), 0);
	printf("message du serveur:  %s", buffer_sortie);	

}

FILE * commandeMAIL(char *buffer, int s)
{

	char buffer_sortie[1024];
	char addr_expediteur[256];
	char *acc_ouvr,*acc_ferm;
	acc_ouvr=strchr(buffer,'<');
	acc_ferm=strchr(buffer,'>');
	int portee=acc_ferm-(acc_ouvr+1);			                                 
	strncpy(addr_expediteur,(acc_ouvr+1),portee);			                                 
	printf("Expediteur %s\r\n",addr_expediteur);
	char file_users[]="../Messages/Users.txt";
	FILE * fd_users = fopen (file_users,"a+");
	char line [ strlen(addr_expediteur) ]; /* or other suitable maximum line size */
	fclose(fd_users);
	int nb_files=0;
	char expediteur[100];
	sprintf(expediteur, "%s", addr_expediteur);
	char nb_messages[100];
	sprintf(nb_messages,"%i", nb_files );
	char sl[2]="/";
	sprintf(sl, "/");
	char extension[10];
	sprintf(extension, ".txt");
	char racine[100] ;
	sprintf(racine, "../Messages/Sent/");
	if(find_exped(file_users, addr_expediteur)==1)
	{
		strcat(expediteur, sl);
		strcat(racine,expediteur);
		int a= count_files(racine);
		printf("le nombre magique est : %d", a);
		sprintf(nb_messages,"%i", (a+1) );
		strcat(nb_messages,extension);
		strcat(racine,nb_messages);
		printf("La concaténation donne %s\n", racine);
		FILE *fd_message = fopen (racine,"a+");
		printf("le descripteur de fichier est : %s", fd_message);
		sprintf(buffer_sortie, "250 OK expediteur deja connu\r\n");
		send(s, buffer_sortie, strlen(buffer_sortie), 0);
		printf("message du serveur:  %s", buffer_sortie);
		return fd_message;
	}
	else
	{
		strcat(expediteur, sl);
		strcat(racine,expediteur);
		printf("L'autre concaténation donne %s\n", racine);
		FILE * fd_users = fopen (file_users,"a+");
		fprintf(fd_users,"%s\n",addr_expediteur);
		fclose(fd_users);
		mkdir(racine,0777);
		strcat(nb_messages,extension);
		int a= count_files(racine);
		printf("le nombre magique est : %d", a);
		sprintf(nb_messages,"%i", (a+1) );
		strcat(nb_messages,extension);
		strcat(racine,nb_messages);
		FILE *fd_message = fopen (racine,"a+");
		printf("le descripteur de fichier est : %s\n", fd_message);
		sprintf(buffer_sortie, "250 OK expediteur enregistre\r\n");
		send(s, buffer_sortie, strlen(buffer_sortie), 0);	printf("message du serveur:  %s", buffer_sortie);
		return fd_message;
	}
	
}

void commandeRCPT(char *buffer, int s)
{
	char buffer_sortie[1024];
    	sprintf(buffer_sortie, "250 OK recipients memorises\r\n");
	send(s, buffer_sortie, strlen(buffer_sortie), 0);
	printf("message du serveur:  %s", buffer_sortie);

}

FILE * commandeDATA(char *buffer,  int s,FILE * fd_message)
{
	char buffer_sortie[1024];	
	printf("tout est ok jusque la");
	printf("%s", fd_message);                                 
	sprintf(buffer_sortie, "354 Continue, envoyez les donnees\r\n");
	send(s, buffer_sortie, strlen(buffer_sortie), 0);
	printf("message du serveur:  %s", buffer_sortie);
	return fd_message;
}

FILE * commande_traiter_DATA(char *buffer,  int s, FILE * fd_message)
{
	if(strncmp(buffer,"\r\n",2)==0 )
		fprintf (fd_message,"***** CONTENU DU MAIL *****\n");
    	else
		fprintf (fd_message,"%s",buffer);
	return fd_message;
}

FILE* commande_fin_DATA(char *buffer,  int s, FILE* fd_message)
{
	char buffer_sortie[1024];	  
	/*
						if ((lockf(fd_message, F_LOCK, 0)) == -1) 
				{
      		perror("lockf()");
      		exit(EXIT_FAILURE);
    		} 
	*/
	sprintf(buffer_sortie, "250 OK Toutes les données sont recues\r\n");
	send(s, buffer_sortie, strlen(buffer_sortie), 0);
	printf("message du serveur:  %s", buffer_sortie);
	/*
					if ((lockf(fd_message, F_ULOCK, 0)) == -1) 
				{
						perror("u-lockf()");
						exit(EXIT_FAILURE);
    		}
	*/
	fclose(fd_message);
	return fd_message;

}

void commandeQUIT(char *buffer,  int s)
{
	char buffer_sortie[1024];
	sprintf(buffer_sortie, "221 OK on se deconnecte\r\n");
	send(s, buffer_sortie, strlen(buffer_sortie), 0);
	printf("message du serveur:  %s", buffer_sortie);
	//close(s);
	//printf("Client déconnecté");

}


void commandeNOOP(char *buffer, int s)
{
	char buffer_sortie[1024];
	sprintf(buffer_sortie, "220  Service Ready\r\n");
	send(s, buffer_sortie, strlen(buffer_sortie), 0);
	printf("message du serveur:  %s", buffer_sortie);

}

void commandeRSET(char *buffer, int s)
{
	// FAIRE DES MEMSET SUR LES VARIABLES				
	char buffer_sortie[1024];
	sprintf(buffer_sortie, "250 OK on reset tout\r\n");
	send(s, buffer_sortie, strlen(buffer_sortie), 0);
	printf("message du serveur:  %s", buffer_sortie);

}



FILE * redirection_Commandes(char *buffer, int s, FILE * fd_message)
{
    int commande_digit=4; // CONSTANTE
    char buffer_sortie[1024];
    if(strncmp(buffer,"EHLO",commande_digit)==0 || strncmp(buffer,"HELO",commande_digit)==0)
		 commandeHELO(buffer,s);
    else if(strncmp(buffer,"MAIL",commande_digit)==0)
		 fd_message=commandeMAIL(buffer,s);
    else if(strncmp(buffer,"RCPT",commande_digit)==0)
		 commandeRCPT(buffer,s);
    else if(strncmp(buffer,"RSET",commande_digit)==0)
		 commandeNOOP(buffer,s);
    else if(strncmp(buffer,"QUIT",commande_digit)==0)
		commandeQUIT(buffer,s);
	    else 
		{
			sprintf(buffer_sortie, "502 La commande n'est pas implementee\r\n");
			send(s, buffer_sortie, strlen(buffer_sortie), 0);
			printf("message du serveur:  %s", buffer_sortie);
		};

	return fd_message;
}


void gestionClientTCP(int s)
{
	/* Obtient une structure de fichier */
	FILE *dialogue=fdopen(s,"a+"); // acces à un fichier en mode lecture et écriture et append (ne pas écraser)
	if(dialogue==NULL){ perror("gestionClientTCP.fdopen"); exit(EXIT_FAILURE); }

	int dans_message=0;
	FILE* fd_message;

    	char buffer[1024], buffer_sortie[1024];
    
        sprintf(buffer_sortie, "220 localhost SMTP server \r\n");
    	printf("%s", buffer_sortie);
    	send(s, buffer_sortie, strlen(buffer_sortie), 0);

	    while(fgets(buffer,MAX_LIGNE,dialogue)!=NULL)
	    {
		printf("message du client: %s", buffer);
		//scanf("%s",&message_serveur);
		//fprintf(dialogue,"message du serveur:  %s",ligne);
		if(dans_message==0)
		{
				if(strncmp(buffer,"DATA",4)==0)
				{
						 fd_message=commandeDATA(buffer,s,fd_message);
						dans_message=1;
				}
				else
						fd_message=redirection_Commandes(buffer,s,fd_message);
		}
		if(dans_message==1)
		{

				if(strncmp(buffer,".\r\n",3)==0)
				{
						fd_message=commande_fin_DATA(buffer,s,fd_message);
						dans_message=0;
				}
				else
				{
						fd_message=commande_traiter_DATA(buffer,s,fd_message);
				}


	}

	    }
 
	/* Termine la connexion */
	fclose(dialogue);
	#if DEBUG
	printf("client déconnecté\n");
	#endif

}


int multi_gestionClientTCP(int s)
{
	lanceThread(gestionClientTCP,(int) s,0);
	return 0;
}




int main(int argc,char *argv[])
{	
	int s=0; // METTRE EN VARIABLE GLOBALE
	char *machine="localhost"; //127.0.0.1
	char *port_loopback="2525"; // car 25 nécessite root  // METTRE EN CONSTANTE
	char *port_local="4444"; // METTRE EN CONSTANTE

	/* Initialisation du serveur */
	s=initialisationServeurTCP(port_local);

	/* Lancement de la boucle d'ecoute */
	boucleServeurTCP(s,multi_gestionClientTCP);

	/* On termine la connexion */
	shutdown(s,SHUT_RDWR);
}
